<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:dp="http://www.datapower.com/extensions"
  extension-element-prefixes="dp"
>
  <dp:input-mapping  href="store:///pkcs7-convert-input.ffd" type="ffd"/>

  <xsl:template match="/">
    <!-- base64 encode Non-XML input data -->
    <xsl:variable name="input64"
      select="dp:binary-encode(/object/message/node())"/>

    <!-- base64 decode; results in input in case of valid UTF-8 -->
    <xsl:variable name="input"
      select="dp:decode($input64, 'base-64')"/>

    <!-- determine bounday from mime headers -->
    <xsl:variable name="boundary" 
      select="substring-before(
                substring-after($input,'boundary=&quot;'),
                '&quot;'
              )"/>

    <!-- 
       Allow accessing the decoded (quotable-printable) body-part in chained
       service with "Skip" attachment processing by "multipart/related"
    -->
    <dp:set-http-request-header name="'Content-Type'" 
      value="concat('multipart/related; type=&quot;text/xml&quot;; ',
                    'boundary=&quot;',$boundary,'&quot;')" />

  </xsl:template>
    
</xsl:stylesheet>
