<!DOCTYPE xsl:stylesheet [ <!ENTITY LF "<xsl:text>&#10;</xsl:text>"> ]>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:dp="http://www.datapower.com/extensions"
  extension-element-prefixes="dp"
>
  <dp:input-mapping href="store:///pkcs7-convert-input.ffd" type="ffd"/>

  <xsl:output omit-xml-declaration="yes"/>

  <xsl:template match="/">

<xsl:variable name="b64" select="dp:binary-encode(/object/message/node())"/>

    <xsl:value-of select="dp:time-value()"/>&LF;
    <xsl:variable name="hex1">
      <xsl:value-of select="dp:radix-convert( 
                              $b64, 
                              64, 
                              16
                            )" 
      />
    </xsl:variable>


    <xsl:value-of select="dp:time-value()"/>&LF;
    <xsl:variable name="dummy"><dummy/></xsl:variable>

    <dp:set-variable name="'var://context/swa'" value="$dummy" />

    <dp:url-open 
      target="attachment://swa/cid:nonXML" 
      data-type="base64" 
      response="ignore"
    >
      <xsl:value-of select="$b64" />
    </dp:url-open>

    <xsl:variable name="hex2">
      <dp:url-open target="attachment://swa/cid:nonXML?Encode=hexbin"/>
    </xsl:variable>


    <xsl:value-of select="dp:time-value()"/>&LF;
    <xsl:value-of 
      select="dp:radix-convert($hex1,16,64)=dp:radix-convert($hex2,16,64)"/>&LF;
  </xsl:template>

</xsl:stylesheet>
