<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:dp="http://www.datapower.com/extensions"
  extension-element-prefixes="dp"
>
  <dp:input-mapping href="store:///pkcs7-convert-input.ffd" type="ffd"/>

  <xsl:output omit-xml-declaration="yes"/>

  <xsl:template match="/">
    <!-- a SOAP message -->
    <xsl:variable name="dummy">
<env:Envelope xmlns:env="http://schemas.xmlsoap.org/soap/envelope/">
<env:Body>
<dummySOAPnode/>
</env:Body>
</env:Envelope>
    </xsl:variable>


    <!-- create context "swa" with that SOAP message -->
    <dp:set-variable name="'var://context/swa'" value="$dummy" />

    <!-- set Content-Type -->
    <dp:set-http-request-header 
      name="'Content-Type'"      
      value="'application/soap+xml'" 
    />

    <!-- attach binary input data to context "swa" ("nonXML" Content-ID) -->
    <dp:url-open 
      target="attachment://swa/cid:nonXML" 
      data-type="base64" 
      response="ignore"
    >
      <xsl:value-of select="dp:binary-encode(/object/message/node())" />
    </dp:url-open>


    <!-- just for demonstration of DataPower fetch "Encode" capabilities -->
    <ret>
      <dp:url-open target="attachment://swa/cid:nonXML?Encode=base64"/>
      <dp:url-open target="attachment://swa/cid:nonXML?Encode=hexbin"/>
      <dp:url-open target="attachment://swa/cid:nonXML" response="binaryNode"/>
    </ret>
  </xsl:template>

</xsl:stylesheet>
