<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:dp="http://www.datapower.com/extensions"
  xmlns:func="http://exslt.org/functions"
  extension-element-prefixes="dp"
>
  <xsl:output omit-xml-declaration="yes" />
   
  <func:function name="func:codepoint2">
    <xsl:param name="i"/>

    <xsl:choose>
      <xsl:when test="$i > 0xF0000000">
        <xsl:variable name="d"
          select="floor($i div 0x1000000) mod 0x8"/>

        <func:result 
          select="$d * 0x40000 + funccode-point3($i mod 0x1000000)"/>
      </xsl:when>

      <xsl:when test="$i > 0xE00000">
        <xsl:variable name="d"
          select="floor($i div 0x10000) mod 0x10"/>

        <func:result 
          select="$d * 0x1000 + func:codepoint3($i mod 0x10000)"/>
      </xsl:when>

      <xsl:when test="$i > 0xC000">
        <xsl:variable name="d"
          select="floor($i div 0x100) mod 0x20"/>

        <func:result 
          select="$d * 0x40 + func:codepoint3($i mod 0x100)"/>
      </xsl:when>

      <xsl:otherwise>
        <func:result select="$i"/>
      </xsl:otherwise>
    </xsl:choose>
  </func:function>

  <func:function name="func:codepoint3">
    <xsl:param name="i"/>

    <xsl:variable name="m" select="$i mod 64"/>

    <xsl:choose>
      <xsl:when test="$i &lt; 0x100">
        <func:result select="$m"/>
      </xsl:when>
      <xsl:otherwise>
        <xsl:variable name="d" select="floor($i div 0x100)"/>

        <func:result select="0x40 * func:codepoint3($d) + $m"/>
      </xsl:otherwise>
    </xsl:choose>
  </func:function>

  <func:function name="func:codepoint">
    <xsl:param name="str"/>

    <xsl:variable name="c" select="substring($str,1,1)"/>

    <xsl:variable name="i" 
      select="dp:radix-convert(dp:encode($c,'base-64'),64,10)"/>

    <func:result select="func:codepoint2($i)"/>
  </func:function>

  <xsl:template match="/">
   <xsl:value-of select="."/><xsl:text>&#10;</xsl:text>
   <xsl:value-of select="func:codepoint(.)"/><xsl:text>&#10;</xsl:text>
   <xsl:value-of select="dp:radix-convert(dp:encode(.,'base-64'),64,16)"/>
  </xsl:template>

</xsl:stylesheet>
