<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:dp="http://www.datapower.com/extensions"
  extension-element-prefixes="dp"
>
  <xsl:output omit-xml-declaration="yes" />
    
  <xsl:template match="/">
    <!-- get iso-8859-1 encoded data -->
    <xsl:variable name="received">
      <dp:url-open response="binaryNode"
        target="http://dp0-l3/umlaute.iso-8859-1"/>
    </xsl:variable>

    <!-- convert to UTF-8 -->
    <xsl:variable name="utf-8">
      <dp:url-open response="xml" data-type="base64"
        target="http://dp0-l3:2221/iso-8859-1">

        <xsl:value-of 
          select="dp:binary-encode($received/result/binary/node())"/>
      </dp:url-open>
    </xsl:variable>

    <!-- convert to ucs-2 -->
    <xsl:variable name="ucs-2">
      <dp:url-open response="binaryNode"
        target="http://dp0-l3:2222/ucs-2">

        <xsl:copy-of select="$utf-8"/>
      </dp:url-open>
    </xsl:variable>

    <!-- send to binary service expecting ucs-2 encoded data -->
    <xsl:variable name="response">
      <dp:url-open response="xml" data-type="base64"
        target="http://dp0-l3:2221/ucs-2">

        <xsl:value-of 
          select="dp:binary-encode($ucs-2/result/binary/node())"/>
      </dp:url-open>
    </xsl:variable>


    <!-- this is just demo output -->
    <xsl:text>received:&#10;</xsl:text>
    <xsl:copy-of select="$received"/>
    <xsl:text>&#10;&#10;utf-8:&#10;</xsl:text>
    <xsl:copy-of select="$utf-8"/>
    <xsl:text>&#10;&#10;ucs-2:&#10;</xsl:text>
    <xsl:copy-of select="$ucs-2"/>
    <xsl:text>&#10;&#10;response:&#10;</xsl:text>
    <xsl:copy-of select="$response"/>

  </xsl:template>
  
</xsl:stylesheet>
