<!DOCTYPE xsl:stylesheet [ <!ENTITY LF "<xsl:text>&#10;</xsl:text>"> ]>
<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:str="http://exslt.org/strings"
  xmlns:func="http://exslt.org/functions"
  xmlns:dp="http://www.datapower.com/extensions"
  exclude-result-prefixes="dp func str"
>
  <xsl:output omit-xml-declaration="yes" />

  <xsl:import href="s.xsl"/>
 
  <xsl:template name="char">
    <xsl:param name="chr"/>
    <td>
      <xsl:value-of select="func:braille($chr)"/>
    </td>
  </xsl:template>


  <xsl:template match="/">
    <xsl:variable name="ts">
      <xsl:copy-of select="str:tokenize(func:pbm-ascii())"/>
    </xsl:variable>

    <xsl:variable name="lines"  select="$ts/token[position() > 3]"/>

    <xsl:call-template name="formatCheck">
      <xsl:with-param name="format" select="$ts/token[1]"/>
      <xsl:with-param name="width"  select="$ts/token[2]"/>
      <xsl:with-param name="height" select="$ts/token[3]"/>
      <xsl:with-param name="lines"  select="$lines"/>
    </xsl:call-template>


    <table cellpadding="0" cellspacing="0" border="0">&LF;
      <xsl:for-each select="$lines[position() mod 4 = 1]">
        <tr>
          <xsl:apply-templates select="."/>
        </tr>
      </xsl:for-each>
    </table>&LF;
  </xsl:template>
</xsl:stylesheet>
