<xsl:stylesheet version="1.0"
  xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
  xmlns:func="http://exslt.org/functions"
  xmlns:str="http://exslt.org/strings"
  exclude-result-prefixes="func str"
>
  <xsl:include href="s.xsl"/>
 
  <xsl:template name="char">
    <xsl:param name="chr"/>
    <xsl:value-of select="func:braille($chr)"/>
  </xsl:template>


  <xsl:template match="/">
    <xsl:variable name="ts">
      <xsl:copy-of select="str:tokenize(func:pbm-ascii())"/>
    </xsl:variable>

    <xsl:variable name="lines"  select="$ts/token[position() > 3]"/>

    <xsl:call-template name="formatCheck">
      <xsl:with-param name="format" select="$ts/token[1]"/>
      <xsl:with-param name="width"  select="$ts/token[2]"/>
      <xsl:with-param name="height" select="$ts/token[3]"/>
      <xsl:with-param name="lines"  select="$lines"/>
    </xsl:call-template>

    <xsl:apply-templates select="$lines[position() mod 4 = 1]"/>
  </xsl:template>

</xsl:stylesheet>
